package com.steerinfo.baseinfo.meterbasematterinfoold.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.baseinfo.meterbasematterinfoold.model.MeterBaseMatterInfoOld;
import com.steerinfo.baseinfo.meterbasematterinfoold.service.IMeterBaseMatterInfoOldService;
import com.steerinfo.meterwork.except.MarkerMetException;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterBaseMatterInfoOld RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2021-03-10 04:39
 * 类描述
 * 修订历史：
 * 日期：2021-03-10
 * 作者：generator
 * 参考：
 * 描述：MeterBaseMatterInfoOld RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterbasematterinfoolds")
public class MeterBaseMatterInfoOldController extends BaseRESTfulController {

    @Autowired
    IMeterBaseMatterInfoOldService meterBaseMatterInfoOldService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfoold:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseMatterInfoOld> list = meterBaseMatterInfoOldService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterbasematterinfoold:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterBaseMatterInfoOld> list = meterBaseMatterInfoOldService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterBaseMatterInfoOld对象创建")
    @ApiImplicitParam(name = "meterBaseMatterInfoOld", value = "详细实体meterBaseMatterInfoOld", required = true, dataType = "MeterBaseMatterInfoOld")
    //@RequiresPermissions("meterbasematterinfoold:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterBaseMatterInfoOld model) {
        try {
            MeterBaseMatterInfoOld meterBaseMatterInfoOld = meterBaseMatterInfoOldService.add(model);
            return success(meterBaseMatterInfoOld);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfoold:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterBaseMatterInfoOld meterBaseMatterInfoOld = meterBaseMatterInfoOldService.getById(id);
            return success(meterBaseMatterInfoOld);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterBaseMatterInfoOld信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterBaseMatterInfoOld", value = "详细实体meterBaseMatterInfoOld", required = true, dataType = "MeterBaseMatterInfoOld")
    })
    //@RequiresPermissions("meterbasematterinfoold:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterBaseMatterInfoOld model) {
        try {
            model.setId(id);
            MeterBaseMatterInfoOld meterBaseMatterInfoOld = meterBaseMatterInfoOldService.modify(model);
            return success(meterBaseMatterInfoOld);
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterbasematterinfoold:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterBaseMatterInfoOldService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
            ex.printStackTrace();
            throw new MarkerMetException(500, "操作异常！！");
        }
    }
}
